Name:           perl-RDF-Query
Version:        2.918
Release:    1%{?dist}
Summary:        SPARQL 1.1 Query and Update implementation for RDF::Trine
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/RDF-Query
Source0:        https://cpan.metacpan.org/authors/id/G/GW/GWILLIAMS/RDF-Query-%{version}.tar.gz
Patch0:         RDF-Query-2.917-Disable-author-tests.patch
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(Config)
BuildRequires:  perl(inc::Module::Install)
BuildRequires:  perl(Module::Install::Metadata)
BuildRequires:  perl(Module::Install::Scripts)
BuildRequires:  perl(Module::Install::WriteAll)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(constant)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(Data::UUID)
BuildRequires:  perl(DateTime)
BuildRequires:  perl(DateTime::Format::W3CDTF)
BuildRequires:  perl(Digest::MD5)
BuildRequires:  perl(Digest::SHA)
BuildRequires:  perl(Encode)
BuildRequires:  perl(Error)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(I18N::LangTags)
BuildRequires:  perl(JSON) >= 2
BuildRequires:  perl(List::Util)
BuildRequires:  perl(Log::Log4perl)
BuildRequires:  perl(LWP::Simple)
BuildRequires:  perl(LWP::UserAgent)
BuildRequires:  perl(Math::BigInt)
BuildRequires:  perl(MIME::Base64)
BuildRequires:  perl(Module::Pluggable)
BuildRequires:  perl(overload)
BuildRequires:  perl(Parse::RecDescent)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(RDF::Trine) >= 1.004
BuildRequires:  perl(RDF::Trine::Iterator)
BuildRequires:  perl(RDF::Trine::Namespace)
BuildRequires:  perl(RDF::Trine::Node::Blank)
BuildRequires:  perl(RDF::Trine::Node::Literal)
BuildRequires:  perl(RDF::Trine::Node::Resource)
BuildRequires:  perl(RDF::Trine::Node::Variable)
BuildRequires:  perl(RDF::Trine::Statement)
BuildRequires:  perl(RDF::Trine::Statement::Quad)
BuildRequires:  perl(RDF::Trine::VariableBindings)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(Set::Scalar)
BuildRequires:  perl(sort)
BuildRequires:  perl(Storable)
BuildRequires:  perl(Time::HiRes)
BuildRequires:  perl(URI) >= 1.52
BuildRequires:  perl(URI::Escape)
BuildRequires:  perl(URI::file)
BuildRequires:  perl(Geo::Distance) >= 0.09
BuildRequires:  perl(lib)
BuildRequires:  perl(Test::Exception)
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(utf8)
BuildRequires:  perl(Test::JSON) >= 0.03
Requires:       perl(CGI)
Requires:       perl(Exporter)
Recommends:     perl(Geo::Distance) >= 0.09
Requires:       perl(JSON) >= 2
Requires:       perl(URI) >= 1.52

%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((JSON|Test::More|URI)\\)$
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((models\\.pl)\\)

%description
RDF::Query allows SPARQL and RDQL queries to be run against an RDF model,
returning rows of matching results.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness
Requires:       perl(Test::More) >= 0.88
Requires:       perl(Test::JSON) >= 0.03

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n RDF-Query-%{version}
%patch0 -p1
rm -rf inc/*
perl -i -ne 'print $_ unless m{^inc/}' MANIFEST
find examples -type f -exec chmod -x {} +
for F in bin/rqsh examples/*.pl; do
    perl -i -MConfig -pe 's{\A#!/usr/bin/env\s+perl}{$Config{startperl}} if ($. == 1)' "$F"
done
for F in t/*.t t/streams.t.deprecated t/models.pl; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!\s*perl}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a data t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
unset RDFQUERY_DEV_TESTS RDFQUERY_NETWORK_TESTS
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test
%{_fixperms} %{buildroot}/*

%check
unset RDFQUERY_DEV_TESTS RDFQUERY_NETWORK_TESTS
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%doc examples Changes.ttl README
%{_bindir}/*
%{perl_vendorlib}/*
%{_mandir}/man1/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%changelog
* Thu Jun 20 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.918-1
- initial build
